// 公共常量、方法库
let $lj = {}; //export对象
let self = $lj;
//库内private变量、方法

import {productInfo, storageKeySet, eventNameSet} from "./project-set"

// 服务器地址
const baseUrl = "http://223.4.178.191:30058";
const apiUrl = baseUrl + "/api.ashx";
// const transitIp = "192.168.2.43";tp
// const transitPort = 30032;
// const transitIp = "223.4.178.191";
// const transitPort = 30031;
// const cusid = "8ae8faed-5ed1-457e-a12e-860b95e64fd5";

const openWinAnimationType = "movein";
const AnimationSubType = "from_right";
const openWinAnimationDuration = 220;
const openWinDelay = 220;
const toastDuration = 3000;
const toastLocation = "middle";
const showProgressAnimationType = "fade";
const showProgressTitle = "努力加载中...";
const showProgressText = "先喝杯茶...";
const timeOutRequest = 40000;

let longjoeAPI;

function initLongjoeAPI() {
    if (!longjoeAPI) {
        console.log("---------------------------requiring longjoeapi module-----------------------");
        longjoeAPI = api.require('longjoeAPI');
    }
    let serverConnectParams = $lj.getStorage("serverConnectParams");
    if (!serverConnectParams) {
        // alert("未设置服务器连接参数，请在登陆页面重新设置");
        return false;
    }
    let addressParams;
    if (serverConnectParams.cusid) {
        addressParams = {cusid: serverConnectParams.cusid};
    } else if (serverConnectParams.ip && serverConnectParams.port) {

        addressParams = {ip: serverConnectParams.ip, port: serverConnectParams.port};
    } else {
        alert("服务器连接参数异常，请在登陆页面重新设置");
        return false;
    }
    longjoeAPI.setServerAddress(addressParams);
    return true;
}


let isAndroid = (/android/gi).test(navigator.appVersion);

function uzStorage() {
    let ls = window.localStorage;
    if (isAndroid) {
        ls = os.localStorage();
    }
    return ls;
}

//外部可调用的public部分
$lj.getAppBarHeight = function () {
    return 48 + api.safeArea.top;
};
$lj.fixStatusBar = function (el) {
    el.style.paddingTop = api.safeArea.top + 'px';
    return el.offsetHeight;
};
$lj.fixTabBar = function (el) {
    let currentStyle = window.getComputedStyle(el);
    let currentPaddingBottom;
    let targetPaddingBottom = api.safeArea.bottom;
    if (currentStyle.paddingBottom) {
        currentPaddingBottom = Number(currentStyle.paddingBottom.replace('px', ''));
        if (currentPaddingBottom >= targetPaddingBottom) {
            return;
        }
        targetPaddingBottom += currentPaddingBottom;
    }
    el.style.paddingBottom = targetPaddingBottom + 'px';
    if (!el.style.height && currentStyle.display === 'inline-block') {
        el.style.height = el.offsetHeight + api.safeArea.bottom + 'px';
    }
    return el.offsetHeight;
};
$lj.constant = {
    articleImgWidth: 78,
    articleImgHeight: 78,
    cacheDir: ""
};
$lj.getCacheDir = function (callback) {
    if ($lj.constant.cacheDir) {
        callback($lj.constant.cacheDir);
        return;
    }
    initLongjoeAPI();
    longjoeAPI.getLJFile(function (ret) {
            if (ret) {
                if (ret.errMsg) {
                    alert("获取文件路径失败" + ret.errMsg);
                } else {
                    $lj.constant.cacheDir = ret.filedir;
                    callback($lj.constant.cacheDir);
                    console.log(ret.filedir)
                }
            } else {
                console.log("获取文件路径失败");
            }
        }
    );
};
let base64TranModule;
$lj.getBase64TranModule = function () {
    // https://www.apicloud.com/mod_detail/26860
    if (!base64TranModule) {
        base64TranModule = api.require('trans');
    }
    return base64TranModule;
};
let fileHelperModule;
$lj.getFileHelperModule = function () {
    // https://www.apicloud.com/mod_detail/61264
    if (!fileHelperModule) {
        fileHelperModule = api.require("fs");
    }
    return fileHelperModule;
};
let qrScnner;
$lj.getQrScanner = function () {
    if (!qrScnner) {
        qrScnner = api.require('FNScanner');
    }
    return qrScnner;
};
$lj.getPageParam = function () {
    return api.pageParam;
};
$lj.closeWin = function (name) {
    if (name) {
        api.closeWin({name: name});
    } else {
        api.closeWin();
    }

};
String.prototype.myReplace = function(f, e) { //吧f替换成e
    var reg = new RegExp(f, "g"); //创建正则RegExp对象   
    return this.replace(reg, e);
}
$lj.dateformat = function (date, fmt) {
	if (!date) {
        return undefined;
    }
    let dateObject = api.systemType == "ios" ? new Date(date.myReplace('-','/')) : new Date(date);
    if (!fmt) {
        fmt = "yyyy-MM-dd hh:mm:ss";
    }
    let o = {
        "M+": dateObject.getMonth() + 1, //月份
        "d+": dateObject.getDate(), //日
        "h+": dateObject.getHours(), //小时
        "m+": dateObject.getMinutes(), //分
        "s+": dateObject.getSeconds(), //秒
        "q+": Math.floor((dateObject.getMonth() + 3) / 3), //季度
        "S": dateObject.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (dateObject.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (let k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
};
$lj.dateAdd = function (date, yearDiff, monthDiff, dayDiff) {
    let result = new Date(date);
    if (dayDiff) {
        result = new Date(result.getTime() + dayDiff * 24 * 60 * 60 * 1000);
    }
    if (monthDiff) {
        let month = result.getMonth() + monthDiff;
        if (month < 0) {
            result = new Date(result.getFullYear() - 1, month + 12, result.getDate(), result.getHours(), result.getMinutes(), result.getSeconds());
        } else if (month > 11) {
            result = new Date(result.getFullYear() + 1, month - 12, result.getDate(), result.getHours(), result.getMinutes(), result.getSeconds());
        } else {
            result = new Date(result.getFullYear(), month, result.getDate(), result.getHours(), result.getMinutes(), result.getSeconds());
        }
    }
    if (yearDiff) {
        result = new Date(result.getFullYear() + yearDiff, month, result.getDate(), result.getHours(), result.getMinutes(), result.getSeconds());
    }
    return result;
};
// 验证手机号码、电话号码格式格式
$lj.checkTel = function (tel) {
    return /^(\(\d{3,4}\)|\d{3,4}-|\s)?\d{7,14}$/.test(tel);
};
// 获取图片的http地址
$lj.getPicUrl = function (picdata, width, height) {
    if (picdata.indexOf('/img.ashx') !== 0) {
        return picdata;
    }
    let result = baseUrl + picdata;
    if (width) {
        result += '&w=' + width;
    }
    if (height) {
        result += '&h=' + height;
    }
    return result;
};
$lj.postLJRequest = function (method, requestbody, callback, errcallback, hideprogress, hideErrMsg, progressParams) {
    return postLJTCPRequest(method, requestbody, callback, errcallback, hideprogress, hideErrMsg, progressParams);
};

// 发送HTTP请求：直接发送请求
function postLJHTTPRequest(method, requestbody, callback, errcallback) {
    let url = apiUrl;
    let data = {
        method: method,
        requestbody: requestbody
    };
    console.log("-------------------------------------------------------------------------------");
    console.log("method:" + method);
    console.log("requestbody:" + JSON.stringify(requestbody));
    api.showProgress();
    if (api) {
        let start = new Date().getTime();
        api.ajax({
            url: url,
            method: 'post',
            data: {
                values: data,
            }
        }, function (ret, err) {
            let end = new Date().getTime();
            let m = (end - start) / 1000;
            console.log("耗时:" + m + "秒");
            console.log("结果:" + JSON.stringify(ret));
            console.log("-------------------------------------------------------------------------------");
            if (ret) {
                if (ret.ErrMsg) {
                    self.toast(ret.ErrMsg, 2000);
                    if (errcallback != null) {
                        errcallback();
                    }
                } else {
                    callback(ret);
                }

            } else {
                api.alert({
                    msg: ('网络异常,请稍后！')
                });
            }
            api.hideProgress();
        });
    } else {
        $.post(url, data, callback, 'json');
    }
}

// 发送TCP请求：通过调用原生模块发送TCP请求
function postLJTCPRequest(method, requestbody, callback, errcallback, hideprogress, hideErrMsg, progressParams) {
    let hidErrMsgParm = (typeof arguments[5] === "undefined" || arguments[5] == null) ? true : arguments[5];
    if (!initLongjoeAPI()) {
        return;
    }
    let data = {
        method: method,
        requestbody: JSON.stringify(requestbody)
    };
    console.log("-------------------------------------------------------------------------------");
    console.log("method:" + method);
    console.log("requestbody:" + JSON.stringify(requestbody));
    if (!hideprogress) {
        api.showProgress(progressParams);
    }
    let ifTimeOut = 1;
    let start = new Date().getTime();
    longjoeAPI.postLJRequest(
        data,
        function (ret, err) {
            let end = new Date().getTime();
            let m = (end - start) / 1000;
            console.log("耗时:" + m + "秒");
            console.log("结果:" + JSON.stringify(ret));
            console.log("-------------------------------------------------------------------------------");
            if (ret) {
                ifTimeOut = 0;
                if (!hideprogress) {
                    api.hideProgress();
                }

                // if (ret.errCode === "连接池请求异常") {
                //     ret.ErrMsg = "连接失败，网络异常或服务停止!";
                //     if (hidErrMsgParm) {
                //         return;
                //     }
                // }
                if (ret.ErrMsg === "请求超时" && api.systemType === "ios") {
                    $lj.toast('请求超时');
                    return;
                }
                if (!ret.ErrMsg && ret.errCode) {
                    ret.ErrMsg = ret.errCode;
                }
                if (ret.ErrMsg) {
                    if (ret.errCode === "连接池请求异常") {
                        $lj.toast("连接失败，网络异常或服务停止!");
                    } else if (ret.ErrMsg.indexOf("会话") >= 0 || ret.ErrMsg.indexOf("已与服务器失联") >= 0) {
                        $lj.toast(ret.ErrMsg);
                        $lj.sendEvent("token_overdue");
                    } else {
                        alert(ret.ErrMsg);
                    }

                    if (ret.DebugMsg) {
                        alert(ret.DebugMsg);
                    }
                    if (errcallback != null) {
                        errcallback();
                    }
                } else {
                    callback(ret);
                }
            } else {
                api.alert({
                    msg: ('网络异常,请稍后！')
                });
            }
        }
    );
    setTimeout(function () {
        if (ifTimeOut === 1) {
            if (!hideprogress) {
                api.hideProgress();
            }
        }
    }, timeOutRequest);
}

// 设置本地数据库数据
$lj.setStorage = function (key, value) {
    if (!storageKeySet.has(key)) {
        console.error("longjoe-public: storageKey: [" + key + "] is undefined or deprecated");
        return;
    }
    if (arguments.length === 2) {
        let v = value;
        if (typeof v === 'object') {
            v = JSON.stringify(v);
            v = 'obj-' + v;
        } else {
            v = 'str-' + v;
        }
        let ls = uzStorage();
        if (ls) {
            ls.setItem(key, v);
        }
    }
};
// 获取本地数据库数据
$lj.getStorage = function (key) {
    if (!storageKeySet.has(key)) {
        console.error("longjoe-public: storageKey: [" + key + "] is undefined or deprecated");
        return;
    }
    let ls = uzStorage();
    if (ls) {
        let v = ls.getItem(key);
        if (!v) {
            return;
        }
        if (v.indexOf('obj-') === 0) {
            v = v.slice(4);
            return JSON.parse(v);
        } else if (v.indexOf('str-') === 0) {
            return v.slice(4);
        }
    }
};
// 设置点击两次返回键退出应用
$lj.setKeybackClose = function () {
    let count = 0;
    let time1, time2;
    self.addEventListener('keyback', function (ret, err) {
        if (count === 0) {
            time1 = new Date().getTime();
            count = 1;
            self.toast('再按一次返回键退出');
        } else if (count === 1) {
            time2 = new Date().getTime();
            if (time2 - time1 < 3000) {
                api.closeWidget({
                    id: api.appId,
                    retData: {
                        name: 'closeWidget'
                    },
                    silent: true
                });
            } else {
                count = 0;
                self.toast('再按一次返回键退出');
            }
        }
    });
};
// 小提示
$lj.toast = function (msg, duration, location, callback) {
    let _duration = (typeof arguments[1] === "undefined" || arguments[1] == null) ? toastDuration : arguments[1];
    let _location = (typeof arguments[2] === "undefined" || arguments[2] == null) ? toastLocation : arguments[2];
    api.toast({
        msg: msg,
        duration: _duration,
        location: _location
    });
    if (typeof callback === "function") {
        setTimeout(callback, duration);
    }
};
// 加载框
$lj.showProgress = function (title, text, modal, animationType) {
    let _title = (typeof arguments[0] === "undefined" || arguments[0] == null) ? showProgressTitle : arguments[0];
    let _text = (typeof arguments[1] === "undefined" || arguments[1] == null) ? showProgressText : arguments[1];
    let _modal = (typeof arguments[2] === "undefined" || arguments[2] == null) ? true : arguments[2];
    let _animationType = (typeof arguments[3] === "undefined" || arguments[3] == null) ? showProgressAnimationType : arguments[3];
    api.showProgress({
        style: 'default',
        animationType: _animationType,
        title: _title,
        text: _text,
        modal: _modal
    });
};
// 监听事件
$lj.addEventListener = function (eventName, callback, extra) {
    if (!eventNameSet.has(eventName)) {
        console.error("longjoe-public: EventName: [" + eventName + "] is undefined or deprecated");
        return;
    }
    let _extra = (typeof arguments[2] === "undefined" || arguments[2] == null) ? {} : arguments[2];
    api.addEventListener({
        name: eventName,
        extra: _extra
    }, function (ret, err) {
        if (typeof callback === "function") {
            callback(ret);
        }
    });
};
// 触发事件
$lj.sendEvent = function (eventName, extra) {
    if (!eventNameSet.has(eventName)) {
        console.error("longjoe-public: EventName: [" + eventName + "] is undefined or deprecated");
        return;
    }
    let _extra = (typeof arguments[1] === "undefined" || arguments[1] == null) ? {} : arguments[1];
    api.sendEvent({
        name: eventName,
        extra: _extra
    });
};
$lj.removeEventListener = function (eventName) {
    api.removeEventListener({
        name: eventName
    });
};
// 打开新窗口
$lj.openWin = function (name, pageParam, bounces, reload, bgColor, animateDirection) {
    let _pageParam = (typeof arguments[1] === "undefined" || arguments[1] == null) ? api.pageParam : arguments[1];
    let _bounces = (typeof arguments[2] === "undefined" || arguments[2] == null) ? false : arguments[2];
    let _reload = (typeof arguments[3] === "undefined" || arguments[3] == null) ? false : arguments[3];
    let _bgColor = (typeof arguments[4] === "undefined" || arguments[4] == null) ? 'rgba(0,0,0,0)' : arguments[4];
    let _animateDirection = (typeof arguments[5] === "undefined" || arguments[5] == null) ? AnimationSubType : arguments[5];
    let url = getTargetUrl(name);
    if (!url){
        return;
    }
    console.log("openingWin: " + url);
    api.openWin({
        name: name,
        url: url,
        pageParam: _pageParam,
        bgColor: _bgColor,
        bounces: _bounces,
        scrollToTop: true,
        slidBackEnabled: false,
        animation: {
            type: openWinAnimationType,
            subType: _animateDirection,
            duration: openWinAnimationDuration
        },
        delay: api.systemType === "ios" ? 0 : openWinDelay,
        reload: _reload,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false
    });
};

function getTargetUrl(targetWinName) {
    let winMap = webpackConfigParams.winMap;
    let curentUrl;
    if (api.winName === "root") {
        curentUrl = winMap["main"];
    } else {
        curentUrl = winMap[api.winName];
    }
    let targetUrl = winMap[targetWinName];
    if (!targetUrl) {
        alert("页面丢失："+targetWinName);
        return;
    }
    let currentUrlStack = curentUrl.split("/");
    let targetUrlStack = targetUrl.split("/");
    let relativeUrl = targetUrl;
    let backStep = currentUrlStack.length - 1;
    for (let i in currentUrlStack) {
        if (currentUrlStack[i] && targetUrlStack[i]) {
            if (currentUrlStack[i] === targetUrlStack[i]) {
                backStep--;
                relativeUrl = relativeUrl.substring(relativeUrl.indexOf('/') + 1);
            } else {
                break;
            }
        }
    }
    if (backStep === 0) {
        relativeUrl = "./" + relativeUrl;
    } else {
        for (let i = 0; i < backStep; i++) {
            relativeUrl = "../" + relativeUrl;
        }
    }
    return relativeUrl + ".html";
}

$lj.getEditHabit = function (properties) {
    if (!properties || !properties instanceof Array) {
        return undefined;
    }
    let userEditHabit = $lj.getStorage("userEditHabit") || {};
    let key = api.winName;
    let habit = userEditHabit[key] || {};
    let result = {};
    for (let prop of properties) {
        result[prop] = habit[prop];
    }
    return result;
};
$lj.setEditHabit = function (data, properties) {
    if (!data || !properties || !properties instanceof Array) {
        return;
    }
    let userEditHabit = $lj.getStorage("userEditHabit") || {};
    let key = api.winName;
    let habit = userEditHabit[key] || {};
    for (let prop of properties) {
        habit[prop] = data[prop];
    }
    userEditHabit[key] = habit;
    $lj.setStorage("userEditHabit", userEditHabit);
};


$lj.oubamaPrintLines = function (lines) {
    initLongjoeAPI();
    let basePrintParams = {
        sendType: 0,  //*必填 int，打印类型 0：打印文字，1：打印条码，2：打印图片（暂不支持）
        printMsg: "", //*必填 string，打印信息
        codeWidth: 1, //*sendtype未1时必填 int, 由于纸长度的原因，宽度width为1-2，宽度为2时最多打印14位，高度heigth为0-255，宽度为1时可通过调整速度和浓度来调整清晰度
        codeHeight: 80, //*sendtype未1时必填 int
        pagerLine: 1, //选填 int, 走纸行数
        concentration: 0, //选填 int，打印浓度设置 1最淡,0正常,2最浓，也可以与速度配合调整浓度
        speed: 7, //选填 int, 打印速度设置 打印速度 0-7 递减，打印图片时速度越慢越顺畅
        lineWidth: 10, //选填 int, 设置行距 0-255
        alignment: 0, //选填 int, 对齐方式 0左对齐，1中间对齐，2右对齐
        underLine: 0, //选填 int, 下划线 0 取消下划线模式1 选择下划线模式(1点宽)2 选择下划线模式(2点宽)
        rigthwidth: 0 //选填 Int, 右间距 0-255
    };
    try {
        for (let line of lines) {
            let printParams = Object.assign(basePrintParams,line);
            longjoeAPI.printSend(printParams, function (ret) {
                if (ret) {
                    if (ret.errMsg) {
                        throw ret.errMsg;
                    }
                } else {
                    throw "获取失败";
                }
            });
        }
    }catch (e) {
        alert(e);
    }
};
$lj.getVersion = function () {
    return api.appVersion;
};
$lj.checkAppUpdate = function (checkPassCallback, updateCallback, progressCallback) {
    if (api.systemType === "ios" || !initLongjoeAPI()) {
        if (checkPassCallback) {
            checkPassCallback();
        }
        return;
    }
    let cacheDir = $lj.constant.cacheDir;
    if (!cacheDir) {
        $lj.getCacheDir(function (cacheDir) {
            if (cacheDir) {
                $lj.checkAppUpdate(checkPassCallback, updateCallback, progressCallback);
            }
        });
        return;
    }
    let updateRequest = {
        appname: productInfo.productCode,
        oldmd5: $lj.getVersion(),
        type: 0
    };
    let serverConnectParams = $lj.getStorage("serverConnectParams");
    if (serverConnectParams.cusid) {
        updateRequest.type = 1;
    }

    $lj.postLJRequest("GetTVUpdate", updateRequest, function (ret) {
        let fileName = productInfo.productCode + "_" + ret.newmd5.replace(/\./g, "_") + ".apk";
        if (ret.apkdata) {
            // 更新
            updateApp(ret.apkdata, fileName, updateCallback);
        }else if (ret.url) {
            let newpath = cacheDir + "/" + fileName;
            api.download({
                url: ret.url,
                savePath: newpath,
                report: true,
                cache: true,
                allowResume: true
            }, function(ret, err) {
                console.log(JSON.stringify(ret));
                if (ret.state === 1) {
                    //下载成功
                    updateApp(fileName, fileName, updateCallback);
                } else {
                    if (progressCallback){
                        progressCallback(ret.percent);
                    }
                }
            });
        } else {
            // 无需更新
            if (checkPassCallback) {
                checkPassCallback();
            }
        }
    }, function () {
        // 网络请求失败
        if (checkPassCallback) {
            checkPassCallback();
        }
    }, null, null, {title: "下载更新中",text: "请勿退出程序"});
};
let updateApp = function (rawName, newName, updateCallback) {
    let cacheDir = $lj.constant.cacheDir;
    if (!cacheDir) {
        $lj.getCacheDir(function (cacheDir) {
            if (cacheDir) {
                updateApp(rawName, newName, updateCallback);
            }
        });
        return;
    }
    let oldpath = cacheDir + "/" + rawName;
    let newpath = cacheDir + "/" + newName;
    console.log(oldpath);
    console.log(newpath);
    if (oldpath != newpath){
        let fs = $lj.getFileHelperModule();
        let renameRet = fs.renameSync({
            oldPath: oldpath,
            newPath: newpath
        });
        console.log(JSON.stringify(renameRet));
        if (!renameRet.status) {
            alert('重命名文件失败！');
            return;
        }
    }
    if (updateCallback) {
        updateCallback({
            appUri: newpath
        });
    }
};
$lj.photoBrowser = function (images, index, md5list) {
    let imgList;
    let showindex;
    let md5listTemp;
    if (typeof images === "string") {
        imgList = [images];
        showindex = 0;
        md5listTemp = [md5list];
    } else {
        imgList = images;
        showindex = index;
        md5listTemp = md5list;
    }
    var photoBrowser = api.require('photoBrowser');
    photoBrowser.open({
        images: imgList,
        activeIndex: showindex,
        placeholderImg: 'widget://res/img/apicloud.png',
        bgColor: '#fff'
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType === "longPress") {
                api.actionSheet({
                    cancelTitle: '取消',
                    buttons: ['下载图片']
                }, function (val, err) {
                    var index = val.buttonIndex;
                    if (index == 1) {
                        var picIndex = ret.index
                        console.log(picIndex)
                        let user = $lj.getStorage("userInfo");
                        let url;
                        if (user.picBaseUrl) {
                            url = user.picBaseUrl + md5list[picIndex];
                        }
                        var alink = document.createElement("a");
                        alink.href = url;
                        alink.download = "pic"; //图片名
                        alink.click();
                    }
                });
            }
            if (ret.eventType === "click") {
                photoBrowser.close();
                api.removeEventListener({
                    name: 'keyback'
                });
            }
        } else {
            console.log(JSON.stringify(err));
        }
    });
    $lj.addEventListener("keyback", function () {
        photoBrowser.close();
        api.removeEventListener({
            name: 'keyback'
        });
    });
};
$lj.cacheFileByMd5 = function (md5, callback, errcallback) {
    $lj.getCacheDir(function (cacheDir) {
        let path = cacheDir + "/" + md5;
        var fs = $lj.getFileHelperModule();
        console.warn(path);
        fs.exist({
            path: path
        }, function (ret, err) {
            if (ret.exist) {
                callback({path: path});
            } else {
                $lj.postLJRequest("GetCacheFile", {filemd5: md5}, function (ret) {
                    var cacheDir = $lj.constant.cacheDir + "/";
                    let newPath = cacheDir + "/" + md5;
                    if (ret.filedata !== md5) {
                        let oldPath = cacheDir + "/" + ret.filedata;
                        console.log(`!!!!!!!!  lj-img:renaming ${ret.filedata} to ${md5}  !!!`);
                        fs.rename({
                            oldPath: oldPath,
                            newPath: newPath
                        }, function (ret, err) {
                            if (ret.status) {
                                callback({path: newPath});
                            } else {
                                console.error("图片重命名: " + JSON.stringify(err));
                                errcallback({msg: "未知异常：" + JSON.stringify(err)});
                            }
                        });
                    } else {
                        callback({path: newPath});
                    }
                });
            }
        });
    });
};
let docHelperModule;
$lj.getDocInteractionModule = function () {
    // https://docs.apicloud.com/Client-API/Func-Ext/docInteraction
    if (!docHelperModule) {
        docHelperModule = api.require("docInteraction");
    }
    return docHelperModule;
};
$lj.openFileByUrl = function (path, errcallback) {
    let fs = $lj.getFileHelperModule();
    let existRet = fs.existSync({
        path: path
    });
    if (!existRet.exist) {
        if (errcallback) {
            errcallback({type: 1});
        }
        console.log("文件不存在：" + path);
        // fileMap[md5] = undefined;
        // $lj.setStorage("downloadFileMap", fileMap);
        // $lj.openFile(fileName, fileType, md5);
        return;
    }
    let docHelper = $lj.getDocInteractionModule();
    docHelper.open({
        path: path
    }, function (ret, err) {
        if (err) {
            alert("打开文件失败，可能未安装能打开此文件的应用");
            console.log(path);
            console.log(JSON.stringify(err))
        } else {
            // alert(JSON.stringify(ret));
        }
    });
};
$lj.openFile = function (fileName, fileType, md5, fileid, requestType) {
    if (!md5) {
        alert("lj-public：未知异常：获取文件MD5失败");
        return;
    }
    if (fileName.indexOf('.') >= 0) {
        fileName = fileName.substring(0, fileName.indexOf('.') - 1);
    }
    let cacheDir = $lj.constant.cacheDir;
    if (!cacheDir) {
        $lj.getCacheDir(function (cacheDir) {
            if (cacheDir) {
                $lj.openFile(fileName, fileType, md5, fileid, requestType);
            }
        });
        return;
    }
    let fs = $lj.getFileHelperModule();
    let path;
    let fileMap = $lj.getStorage("downloadFileMap");
    if (!fileMap) {
        fileMap = {};
        $lj.setStorage("downloadFileMap", fileMap);
    }
    if (fileMap[md5]) {
        path = cacheDir + "/" + fileMap[md5];
        $lj.openFileByUrl(path, function (ret) {
            if (ret.type === 1) {
                // 不存在
                delete fileMap[md5];
                $lj.setStorage("downloadFileMap", fileMap);
                $lj.openFile(fileName, fileType, md5, fileid, requestType);
            }
        });
    } else {
        let token = $lj.getStorage("token");
        let requestAPI, requestBody, dataPropName, typePropName, namePropName;
        if (!requestType) { //文件所在，可选项:MailAnnex,OADocAnnex,OADemoAnnex,OAFlowDefAnnex,UFile(默认)
            requestType = "UFile"
        }
        if (fileid) {
            requestAPI = "GetFile";
            requestBody = {token: token, type: requestType, id: fileid};
            dataPropName = "data";
        } else {
            requestAPI = "GetCacheFile";
            requestBody = {filemd5: md5};
            dataPropName = "filedata";
            namePropName = "FileName";
            typePropName = "filetype";
        }
        console.log(fileid);
        console.log(JSON.stringify(requestBody));
        $lj.postLJRequest(requestAPI, requestBody, function (ret) {
            if (namePropName && !fileName) {
                fileName = ret[namePropName];
            }
            if (typePropName && !fileType) {
                fileType = ret[typePropName];
            }
            let filedata = ret[dataPropName];
            if (filedata) {
                let filename;
                let tryTime = 0;
                let maxTryTimes = 20;
                while (tryTime < maxTryTimes) {
                    filename = fileName + (tryTime ? (`(${tryTime})`) : "") + "." + fileType;
                    let existRet = fs.existSync({
                        path: cacheDir + "/" + filename
                    });
                    console.log(JSON.stringify(existRet));
                    if (!existRet.exist) {
                        break;
                    }
                    tryTime++;
                }
                if (tryTime >= maxTryTimes) {
                    alert("文件下载失败，超出重试次数" + maxTryTimes);
                    return;
                }
                console.log(`!!!!!!!!  renaming ${filedata} to ${filename}  !!!`);
                let oldpath = cacheDir + "/" + filedata;
                let newpath = cacheDir + "/" + filename;
                console.log(oldpath);
                console.log(newpath);
                let renameRet = fs.renameSync({
                    oldPath: oldpath,
                    newPath: newpath
                });
                console.log(JSON.stringify(renameRet));
                if (!renameRet.status) {
                    alert('重命名文件失败！');
                    return;
                }
                let fileMap = $lj.getStorage("downloadFileMap");
                fileMap[md5] = filename;
                $lj.setStorage("downloadFileMap", fileMap);
                $lj.openFile(fileName, fileType, md5, fileid, requestType);
            } else {
                console.error("文件请求失败,md5: " + md5 + (fileid ? (";fileid:" + fileid) : ""));
            }
        });
    }
};

/**
 * Parse the time to string
 * @param {(Object|string|number)} time
 * @param {string} cFormat
 * @returns {string | null}
 */
 export function parseTime(time, cFormat) {
    if (arguments.length === 0 || !time) {
      return null
    }
    const format = cFormat || '{y}-{m}-{d} {h}:{i}:{s}'
    let date
    if (typeof time === 'object') {
      date = time
    } else {
      if ((typeof time === 'string')) {
        if ((/^[0-9]+$/.test(time))) {
          // support "1548221490638"
          time = parseInt(time)
        } else {
          // support safari
          // https://stackoverflow.com/questions/4310953/invalid-date-in-safari
          time = time.replace(new RegExp(/-/gm), '/')
        }
      }
  
      if ((typeof time === 'number') && (time.toString().length === 10)) {
        time = time * 1000
      }
      date = new Date(time)
    }
    const formatObj = {
      y: date.getFullYear(),
      m: date.getMonth() + 1,
      d: date.getDate(),
      h: date.getHours(),
      i: date.getMinutes(),
      s: date.getSeconds(),
      a: date.getDay()
    }
    const time_str = format.replace(/{([ymdhisa])+}/g, (result, key) => {
      const value = formatObj[key]
      // Note: getDay() returns 0 on Sunday
      if (key === 'a') { return ['日', '一', '二', '三', '四', '五', '六'][value ] }
      return value.toString().padStart(2, '0')
    })
    return time_str
  }
/**
 * 最近时间
 * @param {number} time
 * @param {string} option
 * @returns {string}
 */
 function isSameDay(timeStampA, timeStampB) {
    let dateA = new Date(timeStampA);
    let dateB = new Date(timeStampB);
    return (dateA.setHours(0, 0, 0, 0) == dateB.setHours(0, 0, 0, 0));
}
 $lj.formatTime = function(time, option) {
    if (('' + time).length === 10) {
      time = parseInt(time) * 1000
    } else {
      time = +time
    }
    const d = new Date(time)
    const now = Date.now()
  
    const diff = (now - d) / 1000
  
    // if (diff < 30) {
    //   return '刚刚'
    // } else if (diff < 3600) {
    //   // less 1 hour
    //   return Math.ceil(diff / 60) + '分钟前'
    // } else if (diff < 3600 * 24) {
    //   return Math.ceil(diff / 3600) + '小时前'
    // } else if (diff < 3600 * 24 * 2) {
    //   return '1天前'
    // }
    if (isSameDay(now, d)) {
        let hourMins = parseTime(time, '{h}:{i}')
        return `今天 ${hourMins}`
    }

    if (option) {
      return parseTime(time, option)
    } else {
      return (
        d.getMonth() +
        1 +
        '月' +
        d.getDate() +
        '日' +
        d.getHours() +
        '时' +
        d.getMinutes() +
        '分'
      )
    }
}

/**
 * 金额缩略显示
 * @param s 数值
 * @param n 保留位数
 * @returns {*}
 */
 $lj.numberFormat = function(s,n) {
    n = n !== undefined && n >= 0 && n <= 20 ? n : 2;  
    s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
    let r = n ? "." + s.split(".")[1] : "";
    var l = s.split(".")[0].split("").reverse();
    var t = "";  
    for (var i = 0; i < l.length; i++) {  
        t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");  
    }  
    return t.split("").reverse().join("") + r;
}

export default $lj
